import dill
import os
import barsukov


def save_object(obj, file_name, update=False, full_folder_path=None, script=None):
    if script is None:
        if full_folder_path is None:
            full_folder_path = os.getcwd() 
    else:
        full_folder_path = script.full_folder_path
    full_file_path = os.path.join(full_folder_path, file_name)
    if update:
            with open(full_file_path, 'wb') as file:
                dill.dump(obj, file)
                print("{obj} object successfully saved.")
    else:
        try:
            with open(full_file_path, 'xb') as file:
                dill.dump(obj, file)
                print("{obj} object has been successfully saved.")
        except FileExistsError:
            print(f'Object file already exists. If update, use save_obj(obj={obj}, update=true).')


def load_object(obj_file, full_folder_path=None, script=None):
    ### obj in format objectname.pkl
    if script is None:
        if full_folder_path is None:
            full_folder_path = os.getcwd() 
    else:
        full_folder_path = script.full_folder_path
    full_file_path = os.path.join(full_folder_path, obj_file)
    with open(full_file_path, 'rb') as file:
        instance = dill.load(file)
        print(f'{obj_file} object successfully loaded.')
        return instance
    
